<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: Transform Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_transform.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="class_transform-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Transform Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A class to handle rigid transformations.  
 <a href="class_transform.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_transform_8hpp_source.html">Transform.hpp</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Transform:</div>
<div class="dyncontent">
 <div class="center">
  <img src="class_transform.png" usemap="#Transform_map" alt=""/>
  <map id="Transform_map" name="Transform_map">
<area href="class_billboard_transform.html" title="A class to handle Billboard transformations. " alt="BillboardTransform" shape="rect" coords="0,56,119,80"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aa08ca4266efabc768973cdeea51945ab"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#aa08ca4266efabc768973cdeea51945ab">Transform</a> ()</td></tr>
<tr class="memdesc:aa08ca4266efabc768973cdeea51945ab"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> constructor which does nothing.  <a href="#aa08ca4266efabc768973cdeea51945ab">More...</a><br /></td></tr>
<tr class="separator:aa08ca4266efabc768973cdeea51945ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a13428997892b461d999ca0d75d01ab34"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#a13428997892b461d999ca0d75d01ab34">Transform</a> (int _id)</td></tr>
<tr class="memdesc:a13428997892b461d999ca0d75d01ab34"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> constructor. Applying this <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> without further updates generates undefined behaviour.  <a href="#a13428997892b461d999ca0d75d01ab34">More...</a><br /></td></tr>
<tr class="separator:a13428997892b461d999ca0d75d01ab34"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abba40138d02697e7175fda74379b1945"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#abba40138d02697e7175fda74379b1945">Transform</a> (<a class="el" href="class_mat.html">Mat</a> _m, int _id)</td></tr>
<tr class="memdesc:abba40138d02697e7175fda74379b1945"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> constructor properly initialised with a given homogeneous transformation matrix.  <a href="#abba40138d02697e7175fda74379b1945">More...</a><br /></td></tr>
<tr class="separator:abba40138d02697e7175fda74379b1945"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aee8ca24171a9005d6bf2667d5fe04381"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#aee8ca24171a9005d6bf2667d5fe04381">Transform</a> (double yaw, double pitch, double roll, double dx, double dy, double dz, double scale_x, double scale_y, double scale_z, int _id)</td></tr>
<tr class="separator:aee8ca24171a9005d6bf2667d5fe04381"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af68f2847da11a453652c9eda3c1e6f38"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#af68f2847da11a453652c9eda3c1e6f38">setMat</a> (<a class="el" href="class_mat.html">Mat</a> _mat)</td></tr>
<tr class="memdesc:af68f2847da11a453652c9eda3c1e6f38"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the matrix (<a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a>) associated to this <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>.  <a href="#af68f2847da11a453652c9eda3c1e6f38">More...</a><br /></td></tr>
<tr class="separator:af68f2847da11a453652c9eda3c1e6f38"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2277bcdd410169374f66d55a5892c602"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#a2277bcdd410169374f66d55a5892c602">getMat</a> ()</td></tr>
<tr class="memdesc:a2277bcdd410169374f66d55a5892c602"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the matrix (<a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a>) associated to this <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> (local_tf).  <a href="#a2277bcdd410169374f66d55a5892c602">More...</a><br /></td></tr>
<tr class="separator:a2277bcdd410169374f66d55a5892c602"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a44bcd8141337e772ab0dadaf4d70dc01"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#a44bcd8141337e772ab0dadaf4d70dc01">getGlobalMat</a> ()</td></tr>
<tr class="memdesc:a44bcd8141337e772ab0dadaf4d70dc01"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the global matrix (<a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a>) that is obtained by multiplying all transformations along the hierarchy (invoked with transform() method in <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a>).  <a href="#a44bcd8141337e772ab0dadaf4d70dc01">More...</a><br /></td></tr>
<tr class="separator:a44bcd8141337e772ab0dadaf4d70dc01"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a85f2c4d2e9e37998ef96308b33cc1e05"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#a85f2c4d2e9e37998ef96308b33cc1e05">getGlobalMatInv</a> ()</td></tr>
<tr class="memdesc:a85f2c4d2e9e37998ef96308b33cc1e05"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the inverted global matrix (for normals transformation).  <a href="#a85f2c4d2e9e37998ef96308b33cc1e05">More...</a><br /></td></tr>
<tr class="separator:a85f2c4d2e9e37998ef96308b33cc1e05"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6d505ddbe3c2e9df2c3e42dd2630476f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#a6d505ddbe3c2e9df2c3e42dd2630476f">addChild</a> (<a class="el" href="class_transform.html">Transform</a> *_tf)</td></tr>
<tr class="memdesc:a6d505ddbe3c2e9df2c3e42dd2630476f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds a given transform as a child of this transform.  <a href="#a6d505ddbe3c2e9df2c3e42dd2630476f">More...</a><br /></td></tr>
<tr class="separator:a6d505ddbe3c2e9df2c3e42dd2630476f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0feb936d19fbc6a699dec3714ef0af02"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_transform.html">Transform</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#a0feb936d19fbc6a699dec3714ef0af02">getChild</a> (int _i)</td></tr>
<tr class="separator:a0feb936d19fbc6a699dec3714ef0af02"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5e79111567be939ecd8ef89f38c9c637"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#a5e79111567be939ecd8ef89f38c9c637">update_local_tf</a> (double yaw, double pitch, double roll, double dx, double dy, double dz, double scale_x, double scale_y, double scale_z)</td></tr>
<tr class="separator:a5e79111567be939ecd8ef89f38c9c637"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0d6254a919a5a6f8f66b20b5849da99e"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#a0d6254a919a5a6f8f66b20b5849da99e">update_global_tf</a> ()</td></tr>
<tr class="memdesc:a0d6254a919a5a6f8f66b20b5849da99e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Triggers the recursive update of the global_tf transformation matrices of all <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> objects that are hierarchically below this <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>.  <a href="#a0d6254a919a5a6f8f66b20b5849da99e">More...</a><br /></td></tr>
<tr class="separator:a0d6254a919a5a6f8f66b20b5849da99e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af39e30fa857cdc522b95122649edb5cf"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#af39e30fa857cdc522b95122649edb5cf">update_global_tf</a> (<a class="el" href="class_mat.html">Mat</a> &amp;current)</td></tr>
<tr class="separator:af39e30fa857cdc522b95122649edb5cf"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a9460cedd048ae3d6a8e0680f36638600"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#a9460cedd048ae3d6a8e0680f36638600">id</a></td></tr>
<tr class="memdesc:a9460cedd048ae3d6a8e0680f36638600"><td class="mdescLeft">&#160;</td><td class="mdescRight">The id of this transform.  <a href="#a9460cedd048ae3d6a8e0680f36638600">More...</a><br /></td></tr>
<tr class="separator:a9460cedd048ae3d6a8e0680f36638600"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a18ae73009c329f5444145e0fb9a5f286"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="class_transform.html">Transform</a> * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#a18ae73009c329f5444145e0fb9a5f286">childs</a></td></tr>
<tr class="memdesc:a18ae73009c329f5444145e0fb9a5f286"><td class="mdescLeft">&#160;</td><td class="mdescRight">A Vector of pointers to the set of <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> objects that are hierarchically below this <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>.  <a href="#a18ae73009c329f5444145e0fb9a5f286">More...</a><br /></td></tr>
<tr class="separator:a18ae73009c329f5444145e0fb9a5f286"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a66ac17fab8f59fa9b26ac109b16f6bf0"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#a66ac17fab8f59fa9b26ac109b16f6bf0">local_tf</a></td></tr>
<tr class="separator:a66ac17fab8f59fa9b26ac109b16f6bf0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afa608ba2e982f79002af1a1d674871f4"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#afa608ba2e982f79002af1a1d674871f4">global_tf</a></td></tr>
<tr class="separator:afa608ba2e982f79002af1a1d674871f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac0b7b583f8c67c59c85a3d38d623a010"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_transform.html#ac0b7b583f8c67c59c85a3d38d623a010">global_tf_inv</a></td></tr>
<tr class="memdesc:ac0b7b583f8c67c59c85a3d38d623a010"><td class="mdescLeft">&#160;</td><td class="mdescRight">Inverted global_tf.  <a href="#ac0b7b583f8c67c59c85a3d38d623a010">More...</a><br /></td></tr>
<tr class="separator:ac0b7b583f8c67c59c85a3d38d623a010"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A class to handle rigid transformations. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="aa08ca4266efabc768973cdeea51945ab"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa08ca4266efabc768973cdeea51945ab">&sect;&nbsp;</a></span>Transform() <span class="overload">[1/4]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Transform::Transform </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>A <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> constructor which does nothing. </p>

</div>
</div>
<a id="a13428997892b461d999ca0d75d01ab34"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a13428997892b461d999ca0d75d01ab34">&sect;&nbsp;</a></span>Transform() <span class="overload">[2/4]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Transform::Transform </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>A <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> constructor. Applying this <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> without further updates generates undefined behaviour. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_id</td><td><a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>'s numerial unique identifier (useful for debugging printouts) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="abba40138d02697e7175fda74379b1945"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abba40138d02697e7175fda74379b1945">&sect;&nbsp;</a></span>Transform() <span class="overload">[3/4]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Transform::Transform </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_mat.html">Mat</a>&#160;</td>
          <td class="paramname"><em>_m</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> constructor properly initialised with a given homogeneous transformation matrix. </p>
<p>_m Homogeneous transformation matrix <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_id</td><td><a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>'s numerial unique identifier (useful for debugging printouts) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aee8ca24171a9005d6bf2667d5fe04381"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aee8ca24171a9005d6bf2667d5fe04381">&sect;&nbsp;</a></span>Transform() <span class="overload">[4/4]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Transform::Transform </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>yaw</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>pitch</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>roll</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>dx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>dy</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>dz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>scale_x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>scale_y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>scale_z</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>A <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> constructor properly initialised from orientation and position data. Orientation and position data is assumed to be read with co-moving axes. The order to transformations is as follows: displacement-&gt;yaw-&gt;pitch-&gt;roll-&gt;scale</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">yaw</td><td>Angle of rotation (in radians) around y-axis </td></tr>
    <tr><td class="paramname">pitch</td><td>Angle of rotation (in radians) around x-axis </td></tr>
    <tr><td class="paramname">roll</td><td>Angle of rotation (in radians) around z-axis </td></tr>
    <tr><td class="paramname">dx</td><td>Displacement along x-axis </td></tr>
    <tr><td class="paramname">dy</td><td>Displacement along y-axis </td></tr>
    <tr><td class="paramname">dz</td><td>Displacement along z-axis </td></tr>
    <tr><td class="paramname">scale_x</td><td>Scale along x-axis </td></tr>
    <tr><td class="paramname">scale_y</td><td>Scale along y-axis </td></tr>
    <tr><td class="paramname">scale_z</td><td>Scale along z-axis </td></tr>
    <tr><td class="paramname">_id</td><td><a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>'s numerial unique identifier (useful for debugging printouts) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a6d505ddbe3c2e9df2c3e42dd2630476f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6d505ddbe3c2e9df2c3e42dd2630476f">&sect;&nbsp;</a></span>addChild()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::addChild </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_transform.html">Transform</a> *&#160;</td>
          <td class="paramname"><em>_tf</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Adds a given transform as a child of this transform. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_tf</td><td>Pointer to the child transform. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a0feb936d19fbc6a699dec3714ef0af02"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0feb936d19fbc6a699dec3714ef0af02">&sect;&nbsp;</a></span>getChild()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_transform.html">Transform</a>* Transform::getChild </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_i</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Returns a pointer to the i-th child of this transform (the index i follows the order taken when adding the child transforms with the addChild method)</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_i</td><td>The index of the child to be returned </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to the i-th child transform </dd></dl>

</div>
</div>
<a id="a44bcd8141337e772ab0dadaf4d70dc01"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a44bcd8141337e772ab0dadaf4d70dc01">&sect;&nbsp;</a></span>getGlobalMat()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Transform::getGlobalMat </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the global matrix (<a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a>) that is obtained by multiplying all transformations along the hierarchy (invoked with transform() method in <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a>). </p>
<dl class="section return"><dt>Returns</dt><dd>The matrix (<a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a>) associated to this <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> (global_tf). </dd></dl>

</div>
</div>
<a id="a85f2c4d2e9e37998ef96308b33cc1e05"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a85f2c4d2e9e37998ef96308b33cc1e05">&sect;&nbsp;</a></span>getGlobalMatInv()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Transform::getGlobalMatInv </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the inverted global matrix (for normals transformation). </p>
<dl class="section return"><dt>Returns</dt><dd>The inverted global matrix associated to this <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> (global_tf_inv). </dd></dl>

</div>
</div>
<a id="a2277bcdd410169374f66d55a5892c602"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2277bcdd410169374f66d55a5892c602">&sect;&nbsp;</a></span>getMat()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Transform::getMat </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the matrix (<a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a>) associated to this <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> (local_tf). </p>
<dl class="section return"><dt>Returns</dt><dd>The matrix (<a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a>) associated to this <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>. </dd></dl>

</div>
</div>
<a id="af68f2847da11a453652c9eda3c1e6f38"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af68f2847da11a453652c9eda3c1e6f38">&sect;&nbsp;</a></span>setMat()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::setMat </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_mat.html">Mat</a>&#160;</td>
          <td class="paramname"><em>_mat</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the matrix (<a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a>) associated to this <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>. </p>
<p>_mat The matrix (<a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a>) to be associated to this <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>. </p>

</div>
</div>
<a id="a0d6254a919a5a6f8f66b20b5849da99e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0d6254a919a5a6f8f66b20b5849da99e">&sect;&nbsp;</a></span>update_global_tf() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::update_global_tf </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Triggers the recursive update of the global_tf transformation matrices of all <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> objects that are hierarchically below this <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>. </p>

<p>Reimplemented in <a class="el" href="class_billboard_transform.html#abe16851d9f9d2149ad81e21c7e0dac4a">BillboardTransform</a>.</p>

</div>
</div>
<a id="af39e30fa857cdc522b95122649edb5cf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af39e30fa857cdc522b95122649edb5cf">&sect;&nbsp;</a></span>update_global_tf() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::update_global_tf </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_mat.html">Mat</a> &amp;&#160;</td>
          <td class="paramname"><em>current</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Reimplemented in <a class="el" href="class_billboard_transform.html#ac07c93ce0971a5d9040b177a3ba607bb">BillboardTransform</a>.</p>

</div>
</div>
<a id="a5e79111567be939ecd8ef89f38c9c637"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5e79111567be939ecd8ef89f38c9c637">&sect;&nbsp;</a></span>update_local_tf()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::update_local_tf </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>yaw</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>pitch</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>roll</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>dx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>dy</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>dz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>scale_x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>scale_y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>scale_z</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Updates the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node from orientation and position data. Orientation and position data is assumed to be read with co-moving axes. The order to transformations is as follows: displacement-&gt;yaw-&gt;pitch-&gt;roll-&gt;scale</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">yaw</td><td>Angle of rotation (in radians) around y-axis </td></tr>
    <tr><td class="paramname">pitch</td><td>Angle of rotation (in radians) around x-axis </td></tr>
    <tr><td class="paramname">roll</td><td>Angle of rotation (in radians) around z-axis </td></tr>
    <tr><td class="paramname">dx</td><td>Displacement along x-axis </td></tr>
    <tr><td class="paramname">dy</td><td>Displacement along y-axis </td></tr>
    <tr><td class="paramname">dz</td><td>Displacement along z-axis </td></tr>
    <tr><td class="paramname">scale_x</td><td>Scale along x-axis </td></tr>
    <tr><td class="paramname">scale_y</td><td>Scale along y-axis </td></tr>
    <tr><td class="paramname">scale_z</td><td>Scale along z-axis </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a18ae73009c329f5444145e0fb9a5f286"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a18ae73009c329f5444145e0fb9a5f286">&sect;&nbsp;</a></span>childs</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="class_transform.html">Transform</a>*&gt; Transform::childs</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>A Vector of pointers to the set of <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> objects that are hierarchically below this <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>. </p>

</div>
</div>
<a id="afa608ba2e982f79002af1a1d674871f4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afa608ba2e982f79002af1a1d674871f4">&sect;&nbsp;</a></span>global_tf</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Transform::global_tf</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Homogeneous transformation matrix resulting from chainning all hierarchically above transformations with the local_tf transformation matrix This matrix is updated with the transform method, ideally invoked from the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> object (to go through the hierarchy of transforms) </p>

</div>
</div>
<a id="ac0b7b583f8c67c59c85a3d38d623a010"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac0b7b583f8c67c59c85a3d38d623a010">&sect;&nbsp;</a></span>global_tf_inv</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Transform::global_tf_inv</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Inverted global_tf. </p>

</div>
</div>
<a id="a9460cedd048ae3d6a8e0680f36638600"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9460cedd048ae3d6a8e0680f36638600">&sect;&nbsp;</a></span>id</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Transform::id</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The id of this transform. </p>

</div>
</div>
<a id="a66ac17fab8f59fa9b26ac109b16f6bf0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a66ac17fab8f59fa9b26ac109b16f6bf0">&sect;&nbsp;</a></span>local_tf</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Transform::local_tf</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Homogeneous transformation matrix of this <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>. Set and get this matrix with methods setMat and getMat </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="_transform_8hpp_source.html">Transform.hpp</a></li>
<li>src/<a class="el" href="_transform_8cpp.html">Transform.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_transform.html">Transform</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
